<?php
/**
 * author Sergio Antonio Ochoa Martinez - gnu.java.sergio@gmail.com
 * Copyright (c) 2006-2013 Paco Avila & Josep Llort
 * WebSites: www.openkm.com
 * 
 * No bytes were intentionally harmed during the development of this application.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
defined('_JEXEC') or die;

use openkm\bean\Document;
use openkm\bean\Folder;
?>

<style type="text/css">
    #basic {
        padding: 10px;
    }
</style>
<script type="text/javascript">

    $(document).ready(function() {
        var iDisplayLength = <?php echo $this->rowConfiguration->showEntries; ?>;
        var icon = <?php echo $this->rowConfiguration->icon; ?>;
        var size = <?php echo $this->rowConfiguration->size; ?>;
        var updateDate = <?php echo $this->rowConfiguration->updateDate; ?>;
        var author = <?php echo $this->rowConfiguration->author; ?>;
        var version = <?php echo $this->rowConfiguration->version; ?>;
        var iconValor = false;
        var sizeValor = false;
        var updateDateValor = false;
        var authorValor = false;
        var versionValor = false;
        if (icon == 1) {
            iconValor = true;
        }
        if (size === 1) {
            sizeValor = true;
        }
        if (updateDate == 1) {
            updateDateValor = true;
        }
        if (author == 1) {
            authorValor = true;
        }
        if (version == 1) {
            versionValor = true;
        }
        var asInitVals = new Array();
        var oTable = $('#tablaDesktop').dataTable({
            "bJQueryUI": true,
            "sPaginationType": "full_numbers",
            "iDisplayLength": iDisplayLength,
            "bFilter": false,
            "aoColumns": [
                {"bSortable": false, "bSearchable": false, "bVisible": iconValor},
                {"bSortable": true, "bVisible": true},
                {"bSortable": false, "bVisible": sizeValor},
                {"bSortable": false, "bVisible": updateDateValor},
                {"bSortable": true, "bVisible": authorValor},
                {"bSortable": false, "bVisible": versionValor}
            ],
            "aaSorting": [[0, "asc"]],
            "oLanguage": {
                "sProcessing": "<?php echo JText::_('COM_OPENKM_PLEASE_WAIT') ?>",
                "sLengthMenu": "<?php echo JText::_('COM_OPENKM_SHOW') ?>_MENU_ <?php echo JText::_('COM_OPENKM_ENTRIES') ?>",
                                "sZeroRecords": "<?php echo JText::_('COM_OPENKM_NOTHING_FOUND_SORRY') ?>",
                                "sInfo": "<?php echo JText::_('COM_OPENKM_SHOWING') ?>_START_ <?php echo JText::_('COM_OPENKM_TO') ?> _END_ <?php echo JText::_('COM_OPENKM_OF') ?> _TOTAL_ <?php echo JText::_('COM_OPENKM_ENTRIES') ?>",
                                                "sInfoEmpty": "<?php echo JText::_('COM_OPENKM_SHOWING') ?> 0 <?php echo JText::_('COM_OPENKM_TO') ?> 0 <?php echo JText::_('COM_OPENKM_OF') ?> 0 <?php echo JText::_('COM_OPENKM_ENTRIES') ?>",
                                                                "sInfoFiltered": "(<?php echo JText::_('COM_OPENKM_FILTERED_FROM') ?> _MAX_ <?php echo JText::_('COM_OPENKM_TOTAL_ENTRIES') ?>)",
                                                                "sInfoPostFix": "",
                                                                "sSearch": "<?php echo JText::_('COM_OPENKM_SEARCH'); ?>",
                                                                "sUrl": "",
                                                                "oPaginate": {
                                                                    "sFirst": "<?php echo JText::_('COM_OPENKM_FIRST') ?>",
                                                                    "sPrevious": "<?php echo JText::_('COM_OPENKM_PREVIOUS') ?>",
                                                                    "sNext": "<?php echo JText::_('COM_OPENKM_NEXT') ?>",
                                                                    "sLast": "<?php echo JText::_('COM_OPENKM_LAST') ?>"
                                                                }
                                                            }
                                                        });

                                                        $('#searchBasic').button().click(function() {
                                                            if ($('#formSearch').validationEngine('validate')) {
                                                                document.formSearch.task.value = 'searchBasic';
                                                                document.formSearch.submit();
                                                            }
                                                            return false;
                                                        });
                                                        $('#cbSearchAdvanced').button().click(function() {
                                                                $('#basic').css('display', 'none');
                                                                $('#advanced').css('display', '');
                                                                $('#tablaDesktop_wrapper').css('display', 'none');
                                                                $("#spanAdvancedSearch").css('display', 'none');
                                                        });

                                                        $('#formSearch').validationEngine();
                                                    });
</script>
<?php

function printFolder(Folder $folder, $rowConfiguration) { ?>
    <tr>       
        <td align="center">
            <?php if ($folder->isHasChildren() == 'true') { ?>
                <img src="components/com_openkm/assets/images/menuitem_childs.png" /> 
            <?php } else {
                ?>
                <img src="components/com_openkm/assets/images/menuitem_empty.png" />   
            <?php } ?>            
        </td>
        <td>
            <a  href="index.php?option=com_openkm&view=desktop&task=folder&path=<?php echo $folder->getPath(); ?>" >
                <?php echo substr($folder->getPath(), strrpos($folder->getPath(), '/') + 1); ?>
            </a>
        </td>
        <td>

        </td>
        <td>            
            <?php
            $time = strtotime($folder->getCreated());
            echo date('d/m/Y h:i:s', $time);
            ?>
        </td>        
        <td>
            <?php echo $folder->getAuthor(); ?>
        </td>        
        <td>
        </td> 
    </tr>
    <?php
}

function printDocument(Document $document, $rowConfiguration) {
    ?>
    <tr>
        <td align="center">
            <img src="<?php echo $rowConfiguration->url; ?>/mime/<?php echo $document->getMimeType(); ?>" />            
        </td>
        <td>            
            <a  href="index.php?option=com_openkm&view=desktop&task=download&format=raw&uuid=<?php echo $document->getUuid(); ?>&id=<?php echo $rowConfiguration->idConfiguration; ?>" >                
                <?php echo substr($document->getPath(), strrpos($document->getPath(), '/') + 1); ?>
            </a>               
        </td>
        <td>
            <?php echo formatSize($document->getActualVersion()->getSize()); ?>
        </td>
        <td>
            <?php
            $time = strtotime($document->getCreated());
            echo date('d/m/Y h:i:s', $time);
            ?>
        </td>
        <td>
            <?php echo $document->getAuthor(); ?>
        </td>
        <td>
            <?php echo $document->getActualVersion()->getName(); ?>
        </td>    
    </tr>
    <?php
}

function redondear($numero, $decimales) {
    $factor = pow(10, $decimales);
    return (round($numero * $factor) / $factor);
}

function formatSize($size) {
    $srt = "BIG";
    if ($size / 1024 < 1) {
        $srt = $size + " Bytes";
    } else if ($size / 1048576 < 1) {
        $srt = redondear(($size / 1024), 1) . " KB";
    } else if ($size / 1073741824 < 1) {
        $srt = redondear(($size / 1048576), 1) . " MB";
    } else if ($size / 1099511627776 < 1) {
        $srt = redondear(($size / 1073741824), 1) . " GB";
    }
    return $srt;
}

if ($this->enter == 0) {
    ?>
    <script type="text/javascript">
        $(document).ready(function() {
            $('#send').click(function() {
                document.formAccess.task.value = 'send';
                document.formAccess.submit();
            });

            $("#send").button();
        });
    </script>
    <div class=""> 
        <?php if ($this->message != '') { ?>
            <p style="color: #ff0000;"><?php echo $this->message; ?></p>
        <?php } ?>
        <h3 class="contentpassword-title"><?php echo JText::_('COM_OPENKM_RESTRICTED_CONTENT') ?></h3>
        <p class="contentpassword-description"><?php echo JText::_('COM_OPENKM_PROTECTED_AREA') ?><br>
            <?php echo JText::_('COM_OPENKM_PRIVATE_DESCRIPTION') ?></p>
        <form action= "" method="post" id="formAccess" name="formAccess" class="contentpassword-form">
            <table>
                <tr>
                    <td align="right"><?php echo JText::_('COM_OPENKM_PASSWORD') ?></td>
                    <td><input type="password" name="passwordAccess" id="passwordAccess" value=""/></td>
                    <td><button id="send"><?php echo JText::_('COM_OPENKM_SEND'); ?></button></td>
                </tr>
            </table>        
            <input type="hidden" name="option" value="com_openkm" />
            <input type="hidden" name="view" value="desktop"/>            
            <input type="hidden" name="task" value="" /> 
            <input type="hidden" name="id" value="<?php echo $this->rowConfiguration->idConfiguration; ?>"/>
        </form>
    </div>
    <?php
} else {
    if ($this->error == 0) {
        ?>   
        <h3><?php echo JText::_('COM_OPENKM_PATH'); ?>:
            <?php
            $ruta = $this->session->get('ruta');
            for ($i = 0; $i < count($ruta); $i++) {
                ?>

                <a  href="index.php?option=com_openkm&view=desktop&task=folder&v=1&path=<?php echo $ruta[$i]; ?>" >
                    <?php
                    if ($i != 0) {
                        echo substr($ruta[$i], strrpos($ruta[$i], '/'));
                    } else {
                        echo JText::_('COM_OPENKM_HOME');
                    }
                    ?>                               
                </a>            
            <?php } ?>
        </h3>
        <div id="basic" style="display:inline-block; " width="100%">
            <form method="post" action="" name="formSearch" id="formSearch">
                <span><?php echo JText::_('COM_OPENKM_SEARCH_BY_CONTENT') ?>:</span>    
                <span><input type="text" name="content" id="content" value="" size="50" class="validate[required] text-input"/> </span>
                <span><button id="searchBasic"><img src="components/com_openkm/assets/images/search.png" width="16"  /></button></span>                
                <input type="hidden" name="option" value="com_openkm" />
                <input type="hidden" name="view" value="desktop"/>
                <input type="hidden" name="id" value="<?php echo $this->rowConfiguration->idConfiguration; ?>"/>
                <input type="hidden" name="task" value="" />
                <input type="hidden" name="document" id="document" value="1" checked="checked"/>                       
            </form>
        </div>
        <div id="advanced" style="display: none;">
            <?php require_once ('form.php'); ?>
        </div>
        <span style="float: right; margin: 10px;" id="spanAdvancedSearch" ><input type="checkbox" name="cbSearchAdvanced" id="cbSearchAdvanced" /><label id="lSearch" for="cbSearchAdvanced"><?php echo JText::_('COM_OPENKM_ADVANCED_SEARCH'); ?></label> </span>
        <table id="tablaDesktop" class="display" cellpadding="0" cellspacing="0" border="0">
            <thead>
                <tr>
                    <th > </th>
                    <th > <?php echo JText::_('COM_OPENKM_NAME') ?></th>
                    <th > <?php echo JText::_('COM_OPENKM_SIZE') ?></th>
                    <th> <?php echo JText::_('COM_OPENKM_UPDATE_DATE') ?></th>
                    <th > <?php echo JText::_('COM_OPENKM_AUTHOR') ?></th>
                    <th > <?php echo JText::_('COM_OPENKM_VERSION') ?></th>
                </tr>
            </thead>
            <tbody id="tbodyDesktop">
                <?php
                foreach ($this->folders as $folder) {
                    printFolder($folder, $this->rowConfiguration);
                }

                foreach ($this->documents as $document) {
                    printDocument($document, $this->rowConfiguration);
                }
                ?>
            </tbody>
            <tfoot>
        </table>
    <?php } else { ?>   
        <h2><?php echo JText::_('COM_OPENKM_ERROR_THE_CONFIGURATION_IS_NOT_CORRECT_PLEASE_CHECK_YOUR_OPENKM_CONFIGURATION_TO_CONNECTO_TO') ?>.</h2>
    <?php } ?>
<?php } ?>
