<?php

/**
 * author Sergio Antonio Ochoa Martinez - gnu.java.sergio@gmail.com
 * Copyright (c) 2006-2014 Paco Avila & Josep Llort
 * WebSites: www.openkm.com
 * 
 * No bytes were intentionally harmed during the development of this application.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
defined('_JEXEC') or die;

use openkm\OKMWebServicesFactory;

jimport('joomla.application.component.view');

class OpenKMViewDesktop extends JView {

    private $ws;

    public function display($tpl = null) {

        $layout = JRequest::getVar('layout');
        $app = JFactory::getApplication();
        $params = $app->getParams();
        $name = $params->get('name');

        require_once(JPATH_COMPONENT . DS . 'models' . DS . 'configuration.php');
        $modelConfiguration = new OpenKMModelConfiguration();
        $rowsCongiguration = $modelConfiguration->getObject($name);
        $rowConfiguration = $rowsCongiguration[0];        
        $access = $rowConfiguration->access;
        $okmPath = $rowConfiguration->okmPath;
        $this->assignRef('rowConfiguration', $rowConfiguration);
        $error = 0;
        $enter = 0;

        if ($layout == 'view') {
            if ($access == 'Private') {
                $enter = JRequest::getVar("enter");
                if ($enter == null) {
                    $enter = 0;
                }
            } else {
                $enter = 1;
            }
            if ($enter == 1) {
                try {
                    $this->ws = OKMWebServicesFactory::build($rowConfiguration->url, $rowConfiguration->user, $rowConfiguration->password);                                                            
                    $path = JRequest::getVar('path');
                    if ($path == '' || $path == $okmPath) {
                        $path = $okmPath;
                        $ruta = array();
                        $ruta[] = $path;
                        $session = JFactory::getSession();
                        $session->set('ruta', $ruta);
                    } else {
                        $valor = JRequest::getVar('v');
                        $session = JFactory::getSession();
                        $ruta = $session->get('ruta');
                        if ($valor != 1) {
                            $ruta[] = $path;
                            $session->set('ruta', $ruta);
                        } else {
                            $j = 0;
                            for ($i = 0; $i < count($ruta); $i++) {
                                if ($path == $ruta[$i]) {
                                    $j = $i;
                                }
                            }
                            for ($i = $j; $i < count($ruta); $i++) {
                                unset($ruta[$i]);
                            }
                            $session->set('ruta', $ruta);
                        }
                    }
                    $documents = $this->ws->getDocumentChildren($path);
                    $folders = $this->ws->getFolderChildren($path);
                    $this->assignRef('documents', $documents);
                    $this->assignRef('folders', $folders);
                    $this->assignRef('path', $path);
                    $this->assignRef('error', $error);
                    $this->assignRef('session', $session);
                } catch (Exception $e) {
                    $error = 1;
                    $this->assignRef('error', $error);
                }
            }
            $message = JRequest::getVar('message');
            $this->assignRef('message', $message);
            $this->assignRef('enter', $enter);
        } 
        parent::display($tpl);
    }

}

?>
